Ordr3
=====

Our old and trusted ordering system (developed in 2012) was showing its age. Since the original application had no automatic tests, a complete rewrite was done.

Decisions and goals in this project:

- make a "classical" web app with a little bit Javascript sprinkled in
- [Python](https://www.python.org) as main programming language
- [SQLite](https://duckduckgo.com/) as database backend
- [Pyramid](https://trypyramid.com) as web framework
- leverage the design principles shown in [Cosmic Python](https://github.com/cosmicpython/book/blob/master/Readme.md)
- have automatic unit test and functional tests, the coverage should be above 90%
- complete data migration from the old system

The new system is now online at https://ordr.cpi.imtek.uni-freiburg.de since late April 2020.

## Development

To install the development version of Ordr3:

    git clone https://git.cpi.imtek.uni-freiburg.de/holgi/ordr3.git
    
    # create a virtual environment and install all required dev dependencies
    cd ordr3
    make devenv

To run the tests, use `make tests` or `make coverage` for a complete report. You can also run an autoformatter and linter with `make lint`.
