"""Ordr3

A rewrite of our CPI ordering system.
"""

__version__ = "1.3.0"


from pyramid.config import Configurator
from pyramid.session import JSONSerializer, SignedCookieSessionFactory


def main(global_config, **settings):  # noqa: ARG001
    """This function returns a Pyramid WSGI application."""
    with Configurator(settings=settings) as config:
        session_factory = SignedCookieSessionFactory(
            settings["session.secret"], serializer=JSONSerializer()
        )
        config.set_session_factory(session_factory)
        config.set_default_csrf_options(
            require_csrf=settings["session.auto_csrf"]
        )

        config.include(".adapters")
        config.include(".events")
        config.include(".resources")
        config.include(".routes")
        config.include(".security")
        config.include(".schemas")
        config.include(".views")

        config.scan()

        return config.make_wsgi_app()
